import React from 'react';
import { mount } from 'enzyme';
import toJson from 'enzyme-to-json';
import Icon from '../../icon';
import ConfigProvider from '..';
describe('ConfigProvider', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
  });
  it('when using themeVars prop', function () {
    var themeVars = {
      color: 'red'
    };
    wrapper = mount( /*#__PURE__*/React.createElement(ConfigProvider, {
      themeVars: themeVars
    }, /*#__PURE__*/React.createElement(Icon, {
      name: "success"
    })));
    expect(toJson(wrapper)).toMatchSnapshot();
  });
  it('when using iconPrefix prop', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(ConfigProvider, {
      iconPrefix: "my-icon"
    }, /*#__PURE__*/React.createElement(Icon, {
      name: "success"
    })));
    expect(wrapper.find('i.my-icon-success').exists()).toBeTruthy();
  });
});