import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { mount, shallow } from 'enzyme';
import { Loading } from '..';
describe('Loading', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
    jest.restoreAllMocks();
  });
  it('should change loading size when using size prop', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Loading, {
      size: 20
    }));
    var spinner = wrapper.find('.rc-loading__spinner');
    expect(spinner.getDOMNode().style.width).toEqual('20px');
    expect(spinner.getDOMNode().style.height).toEqual('20px');
  });
  it('should change text font-size when using text-size prop', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Loading, {
      textSize: 20
    }, "Text"));
    expect(wrapper.find('.rc-loading__text').props().style.fontSize).toEqual('20px');
  });
  it('should change text color when using text-color prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Loading, {
              textColor: "red"
            }, "Loading Text"));
            expect(wrapper.find('.rc-loading__text').getDOMNode().style.color).toBe('red');

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should change text color when using color prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Loading, {
              color: "green"
            }, "Loading Text"));
            expect(wrapper.find('.rc-loading__text').getDOMNode().style.color).toBe('green');

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should change text color to textColor when using color & textColor prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Loading, {
              color: "green",
              textColor: "red"
            }, "Loading Text"));
            expect(wrapper.find('.rc-loading__text').getDOMNode().style.color).toBe('red');

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('should render correctly when using type is spinner', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Loading, {
              type: "spinner"
            }));
            expect(wrapper.find('i')).toHaveLength(12);

          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
  it('should render correctly when using type is ball', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            wrapper = shallow( /*#__PURE__*/React.createElement(Loading, {
              type: "ball"
            }));
            expect(wrapper.find('BallIcon').exists()).toBeTruthy();

          case 2:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })));
});