import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { mount, shallow } from 'enzyme';
import Icon from '../../icon';
import Checker from '../../checkbox/Checker';
import { Radio } from '..';
describe('Radio', function () {
  afterEach(function () {
    jest.restoreAllMocks();
  });
  it('should emit "update:modelValue" event when radio icon or label is clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var onClick, wrapper, icon, label;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              onClick: onClick,
              defaultChecked: false
            }, "\u5355\u9009\u6846"));
            icon = wrapper.find('.rc-radio__icon');
            label = wrapper.find('.rc-radio__label');
            icon.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(1);
            _context.next = 8;
            return wrapper.setProps({
              checked: false
            });

          case 8:
            label.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(2);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should not emit "update:modelValue" event when radio icon is disabled and clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var onChange, wrapper;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              onChange: onChange,
              defaultChecked: true,
              disabled: true
            }, "\u5355\u9009\u6846"));
            wrapper.find('.rc-radio__icon').simulate('click');
            expect(onChange).not.toHaveBeenCalled();

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should render "rc-radio--label-disabled" class when using label-disabled prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
      name: "a",
      defaultChecked: true,
      labelDisabled: true
    }, "\u5355\u9009\u6846"));
    expect(wrapper.find('.rc-radio--label-disabled')).toBeTruthy();
  });
  it('should not emit "update:modelValue" event when label is disabled and clicked', function () {
    var onChange = jest.fn();
    var wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
      name: "a",
      onChange: onChange,
      defaultChecked: true,
      labelDisabled: true
    }, "\u5355\u9009\u6846"));
    var label = wrapper.find('.rc-radio__label');
    label.simulate('click');
    expect(onChange).not.toHaveBeenCalled();
  });
  it('should adjust label position when using label-position prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
      name: "a",
      defaultChecked: true,
      labelPosition: "left"
    }, "\u5355\u9009\u6846"));
    expect(wrapper.find('.rc-radio__label--left')).toBeTruthy();
  });
  it('should emit click event when radio icon is clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    var onClick, wrapper;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              defaultChecked: true,
              onClick: onClick
            }, "\u5355\u9009\u6846"));
            wrapper.simulate('click');
            expect(onClick).toHaveBeenCalled();

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('should emit click event when radio icon is clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    var onClick, wrapper;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio, {
              name: "a",
              defaultChecked: true,
              onClick: onClick
            }, "\u5355\u9009\u6846"));
            wrapper.simulate('click');
            expect(onClick).toHaveBeenCalled();

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
  it('should render Radio.Group correctly when using defaultValue prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
    var wrapper;
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Radio.Group, {
              defaultValue: "1"
            }, /*#__PURE__*/React.createElement(Radio, {
              name: "1"
            }, "\u5355\u9009\u6846 1"), /*#__PURE__*/React.createElement(Radio, {
              name: "2"
            }, "\u5355\u9009\u6846 2")));
            expect(wrapper.find(Checker).at(0).props().checked).toBeTruthy();

          case 2:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })));
  it('should render Radio.Group correctly when using direction prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
    var wrapper;
    return _regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Radio.Group, {
              direction: "horizontal"
            })));
            expect(wrapper.find('.rc-radio-group--horizontal').exists()).toBeTruthy();

          case 2:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  })));
  it('should render Radio.Group correctly when using disabled prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7() {
    var onClick, onChange, wrapper;
    return _regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            onClick = jest.fn();
            onChange = jest.fn();
            wrapper = shallow( /*#__PURE__*/React.createElement(Radio.Group, {
              defaultValue: "1",
              disabled: true,
              onChange: onChange
            }, /*#__PURE__*/React.createElement(Radio, {
              name: "1"
            }, "\u5355\u9009\u6846 1"), /*#__PURE__*/React.createElement(Radio, {
              name: "2",
              onClick: onClick
            }, "\u5355\u9009\u6846 2")));
            wrapper.find(Radio).at(1).simulate('click');
            expect(onChange).not.toHaveBeenCalled();

          case 5:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  })));
  it('should render Radio.Group correctly when using iconSize prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8() {
    var wrapper;
    return _regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Radio.Group, {
              defaultValue: "1",
              iconSize: "30"
            }, /*#__PURE__*/React.createElement(Radio, {
              name: "1"
            }, "\u5355\u9009\u6846 1"), /*#__PURE__*/React.createElement(Radio, {
              name: "2"
            }, "\u5355\u9009\u6846 2")));
            wrapper.find('.rc-radio__icon').forEach(function (element) {
              expect(element.props().style.fontSize).toEqual('30px');
            });

          case 2:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  })));
  it('should render Radio.Group correctly when using checkedColor prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9() {
    var wrapper;
    return _regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Radio.Group, {
              defaultValue: "1",
              checkedColor: "red"
            }, /*#__PURE__*/React.createElement(Radio, {
              name: "1"
            }, "\u5355\u9009\u6846 1"), /*#__PURE__*/React.createElement(Radio, {
              name: "2"
            }, "\u5355\u9009\u6846 2")));
            expect(wrapper.find(Icon).at(0).props().style.backgroundColor).toEqual('red');
            _context9.next = 4;
            return wrapper.find(Icon).at(1).simulate('click');

          case 4:
            expect(wrapper.find(Icon).at(0).props().style.backgroundColor).toBeFalsy();

          case 5:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9);
  })));
  it('should emit onChange event in Radio.Group', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10() {
    var onChange, wrapper;
    return _regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Radio.Group, {
              defaultValue: "1",
              onChange: onChange
            }, /*#__PURE__*/React.createElement(Radio, {
              name: "1"
            }, "\u5355\u9009\u6846 1"), /*#__PURE__*/React.createElement(Radio, {
              name: "2"
            }, "\u5355\u9009\u6846 2")));
            _context10.next = 4;
            return wrapper.find(Icon).at(1).simulate('click');

          case 4:
            expect(onChange).toHaveBeenCalledWith('2');

          case 5:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10);
  })));
});