import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { mount } from 'enzyme';
import '@testing-library/jest-dom/extend-expect';
import Rate from '..';
describe('Rate', function () {
  it('should emit change event when rate icon is clicked', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var onChange, wrapper, item4;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
              onChange: onChange,
              defaultValue: 0
            }));
            item4 = wrapper.find('.rc-rate__item').at(3);
            expect(wrapper.find('i.rc-rate__icon--full').length).toBe(0);
            _context.next = 6;
            return item4.simulate('click');

          case 6:
            expect(onChange).toHaveBeenCalledTimes(1);
            expect(onChange.mock.calls[0][0]).toEqual(4);
            expect(wrapper.find('i.rc-rate__icon--full').length).toBe(4);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should not emit change event when rate is not changed', function () {
    var onChange = jest.fn();
    var wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
      onChange: onChange,
      value: 4
    }));
    var item4 = wrapper.find('.rc-rate__item').at(3);
    item4.simulate('click');
    expect(onChange).not.toHaveBeenCalled();
    expect(wrapper.find('i.rc-rate__icon--full').length).toBe(4);
  });
  it('should not emit change or update:modelValue event when rate is disabled', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var onChange, wrapper, item4;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
              onChange: onChange,
              disabled: true
            }));
            item4 = wrapper.find('.rc-rate__item').at(3);
            item4.simulate('click');
            expect(onChange).not.toHaveBeenCalled();
            expect(wrapper.find('i.rc-rate__icon--full').length).not.toBe(4);

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should render gutter when using gutter prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
      gutter: 10
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should change icon size when using size prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
      size: "2rem"
    }));
    wrapper.find('i.rc-rate__icon').forEach(function (el) {
      expect(el.getDOMNode().style.fontSize).toEqual('2rem');
    });
  });
  it('should get decimal when using allow-half and readonly prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
      allowHalf: true,
      readonly: true,
      value: 2.3
    }));
    var halfIcon = wrapper.find('i.rc-rate__icon--half');
    expect(halfIcon.getDOMNode().style.width).toEqual('0.3em');
  });
  it('should render correct count when using string prop', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
      count: 4
    }));
    var icons = wrapper.find('.rc-rate__item');
    expect(icons).toHaveLength(4);
  });
  it('should emit click event correctly with allowHalf', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    var onChange, wrapper;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
              allowHalf: true,
              onChange: onChange
            }));
            wrapper.find('.rc-rate__item').at(4).simulate('click', {
              clientX: 92
            });
            expect(onChange).toHaveBeenCalledWith(5);
            wrapper.find('.rc-rate__item').at(0).simulate('click');
            expect(onChange).toHaveBeenCalledWith(0.5);

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('touchMove event', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    var onChange, wrapper;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            onChange = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Rate, {
              onChange: onChange
            }));
            wrapper.simulate('touchstart', {
              touches: [{
                clientX: 0,
                clientY: 0
              }]
            });
            wrapper.simulate('touchmove', {
              touches: [{
                clientX: 100,
                clientY: 0
              }]
            });
            expect(onChange).toHaveBeenCalled();

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
});