import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { mount } from 'enzyme';
import { Switch } from '..';
describe('Switch', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
    jest.restoreAllMocks();
  });
  it('should emit onClick event when click the switch button', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var onClick;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
              defaultChecked: false,
              onClick: onClick
            }));
            wrapper.simulate('click');
            expect(onClick).toHaveBeenCalledTimes(1);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should emit change event when click the switch button', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var onChange, onClick;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onChange = jest.fn();
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
              defaultChecked: false,
              onClick: onClick,
              onChange: onChange
            }));
            _context2.next = 5;
            return wrapper.simulate('click');

          case 5:
            expect(onChange).toHaveBeenCalledWith(true);
            _context2.next = 8;
            return wrapper.simulate('click');

          case 8:
            expect(onChange).toHaveBeenCalledWith(false);

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should not emit change event if disabled', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    var onChange, onClick;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onChange = jest.fn();
            onClick = jest.fn();
            wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
              defaultChecked: false,
              disabled: true,
              onClick: onClick,
              onChange: onChange
            }));
            _context3.next = 5;
            return wrapper.simulate('click');

          case 5:
            expect(onChange).toHaveBeenCalledTimes(0);

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('should change active color when using active-color prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
              defaultChecked: true,
              activeColor: "black"
            }));
            expect(wrapper.getDOMNode().style.backgroundColor).toEqual('black');
            wrapper.setProps({
              activeColor: 'red'
            });
            expect(wrapper.getDOMNode().style.backgroundColor).toEqual('red');

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
  it('should change inactive color when using inactive-color prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
              defaultChecked: false,
              inactiveColor: "black"
            }));
            expect(wrapper.getDOMNode().style.backgroundColor).toEqual('black');
            _context5.next = 4;
            return wrapper.setProps({
              inactiveColor: 'red'
            });

          case 4:
            wrapper.update();
            expect(wrapper.getDOMNode().style.backgroundColor).toEqual('red');

          case 6:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })));
  it('should apply active color to loading icon', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
      defaultChecked: true,
      loading: true,
      activeColor: "red"
    }));
    var loading = wrapper.find('.rc-switch__loading').at(0);
    expect(loading.props().color).toEqual('red');
  });
  it('should apply inactive color to loading icon', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
      defaultChecked: false,
      loading: true,
      inactiveColor: "red"
    }));
    var loading = wrapper.find('.rc-switch__loading').at(0);
    expect(loading.props().color).toEqual('red');
  });
  it('should change size when using size prop', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Switch, {
      size: 20
    }));
    expect(wrapper.getDOMNode().style.fontSize).toEqual('20px');
  });
});