import React from 'react';
import { mount } from 'enzyme';
import { Tag } from '..';
describe('Tag', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
  });
  it('should emit close event when clicking the close icon', function () {
    var onClose = jest.fn();
    wrapper = mount( /*#__PURE__*/React.createElement(Tag, {
      closeable: true,
      onClose: onClose
    }));
    wrapper.find('.rc-tag__close').at(0).simulate('click');
    expect(onClose).toHaveBeenCalledTimes(1);
  });
  it('should hide tag when the show prop is false', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Tag, {
      visible: false
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should not trigger click event when clicking the close icon', function () {
    var onClick = jest.fn();
    wrapper = mount( /*#__PURE__*/React.createElement(Tag, {
      closeable: true,
      onClick: onClick
    }));
    wrapper.find('.rc-tag__close').at(0).simulate('click');
    expect(onClick).toHaveBeenCalledTimes(0);
    wrapper.simulate('click');
    expect(onClick).toHaveBeenCalledTimes(1);
  });
  it('should render border-color correctly', function () {
    wrapper = mount( /*#__PURE__*/React.createElement(Tag, {
      plain: true,
      color: "red",
      textColor: "blue"
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
});