"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _enzymeToJson() {
  var data = _interopRequireDefault(require("enzyme-to-json"));

  _enzymeToJson = function _enzymeToJson() {
    return data;
  };

  return data;
}

var _icon = _interopRequireDefault(require("../../icon"));

var _ = _interopRequireDefault(require(".."));

describe('Button', function () {
  it('renders correctly', function () {
    expect( /*#__PURE__*/_react().default.createElement(_.default, null)).toMatchRenderedSnapshot();
  });
  it('mount correctly', function () {
    expect(function () {
      return (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, null));
    }).not.toThrow();
  });
  it('should render empty button without errors', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, null, null, undefined));
    expect(wrapper.render()).toMatchSnapshot();
  });
  it('should simulate click event', function () {
    var onClick = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      onClick: onClick
    }));
    wrapper.simulate('click');
    expect(onClick).toHaveBeenCalledTimes(1);
  });
  it('should not emit click event when disabled', function () {
    var onClick = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      disabled: true,
      onClick: onClick
    }));
    wrapper.simulate('click');
    expect(onClick).not.toHaveBeenCalled();
  });
  it('should render correctly when loading prop is set', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      type: "primary",
      loading: true
    }));
    expect(wrapper.find('.rc-loading__spinner').exists()).toBeTruthy();
  });
  it('should hide border when color is gradient', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      color: "linear-gradient(#000, #fff)"
    }));
    expect(wrapper.getDOMNode().style.border).toEqual('0px');
  });
  it('should hide border when color is not gradient', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      type: "primary",
      color: "red"
    }));
    expect(wrapper.getDOMNode().style.borderColor).toEqual('red');
  });
  it('should change icon class prefix when using icon-prefix prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      icon: "success",
      iconPrefix: "my-icon"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render correctly when icon is JSX element', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      icon: /*#__PURE__*/_react().default.createElement(_icon.default, {
        name: "shop-o"
      })
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render iconPosition correctly', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      type: "primary",
      iconPosition: "right"
    }));
    expect(wrapper.find('.rc-loading__spinner').exists()).toBeFalsy();
  });
  it('should render buttton group correctly', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default.Group, null, /*#__PURE__*/_react().default.createElement(_.default, {
      type: "primary"
    }, "next step")));
    expect(wrapper.find('.rc-button-group').exists()).toBeTruthy();
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
});