"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _enzymeToJson() {
  var data = _interopRequireDefault(require("enzyme-to-json"));

  _enzymeToJson = function _enzymeToJson() {
    return data;
  };

  return data;
}

var _ = _interopRequireDefault(require(".."));

describe('Cell', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
    jest.restoreAllMocks();
  });
  it('should render value slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      value: "Custom Value"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render title slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Custom Title"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render label slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Title",
      label: "Custom Label"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render icon slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      icon: "location-o"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render extra slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Title",
      value: "Value",
      extra: "Custom Extra"
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should change arrow direction when using arrow-direction prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Title",
      value: "Value",
      isLink: true,
      arrowDirection: "down"
    }));
    expect(wrapper.find('.rc-cell__right-icon').exists()).toBeTruthy();
    expect(wrapper.find('.van-icon-arrow-down').exists()).toBeTruthy();
  });
  it('should change title style when using title-style prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Title",
      titleStyle: {
        color: 'red'
      }
    }));
    var title = wrapper.find('.rc-cell__title');
    expect(title.getDOMNode().style.color).toEqual('red');
  });
  it('should change icon class prefix when using icon-prefix prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Title",
      icon: "success",
      iconPrefix: "my-icon"
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should allow to disable clicakble when using is-link prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      title: "Title",
      isLink: true,
      clickable: false
    }));
    expect(wrapper.find('.rc-cell--clickable').exists()).toBeTruthy();
  });
  it('should render correctly when wrapperd with Cell.Group', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default.Group, null, /*#__PURE__*/_react().default.createElement(_.default, {
      title: "\u5355\u5143\u683C",
      value: "\u5185\u5BB9"
    }), /*#__PURE__*/_react().default.createElement(_.default, {
      title: "\u5355\u5143\u683C",
      value: "\u5185\u5BB9",
      label: "\u63CF\u8FF0\u4FE1\u606F"
    })));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render correctly when using title prop in Cell.Group', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement("div", null, /*#__PURE__*/_react().default.createElement(_.default.Group, {
      title: "\u5206\u7EC41"
    }, /*#__PURE__*/_react().default.createElement(_.default, {
      title: "\u5355\u5143\u683C",
      value: "\u5185\u5BB9"
    })), /*#__PURE__*/_react().default.createElement(_.default.Group, {
      title: "\u5206\u7EC42"
    }, /*#__PURE__*/_react().default.createElement(_.default, {
      title: "\u5355\u5143\u683C",
      value: "\u5185\u5BB9"
    }))));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
  it('should render correctly when using inset prop in Cell.Group', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default.Group, {
      inset: true
    }, /*#__PURE__*/_react().default.createElement(_.default, {
      title: "\u5355\u5143\u683C",
      value: "\u5185\u5BB9"
    }), /*#__PURE__*/_react().default.createElement(_.default, {
      title: "\u5355\u5143\u683C",
      value: "\u5185\u5BB9",
      label: "\u63CF\u8FF0\u4FE1\u606F"
    })));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
});