"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _enzymeToJson() {
  var data = _interopRequireDefault(require("enzyme-to-json"));

  _enzymeToJson = function _enzymeToJson() {
    return data;
  };

  return data;
}

var _ = _interopRequireDefault(require(".."));

var _button = _interopRequireDefault(require("../../button"));

describe('Dialog', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
    jest.clearAllMocks();
  });
  it('should change confirm button color when using confirm-button-color prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      confirmButtonColor: "red"
    }));
    var confirmButton = wrapper.find('.rc-dialog__confirm').at(0);
    expect(confirmButton.getDOMNode().style.color).toEqual('red');
  });
  it('should change cancel button color when using cancel-button-color prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      showCancelButton: true,
      cancelButtonColor: "red"
    }));
    var cancelButton = wrapper.find('.rc-dialog__cancel').at(0);
    expect(cancelButton.getDOMNode().style.color).toEqual('red');
  });
  it('should render button text correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      showCancelButton: true,
      cancelButtonText: "Custom Cancel",
      confirmButtonText: "Custom Confirm"
    }));
    expect(wrapper.find('.rc-dialog__footer').html()).toMatchSnapshot();
  });
  it('should render default slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      message: "Custom Message"
    }));
    expect(wrapper.find('.rc-dialog__message').text()).toEqual('Custom Message');
    expect(wrapper.find('.rc-dialog__content').html()).toMatchSnapshot();
  });
  it('should render title slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      title: "Custom Title"
    }));
    expect(wrapper.find('.rc-dialog__header').text()).toEqual('Custom Title');
    expect((0, _enzymeToJson().default)(wrapper.find('.rc-dialog__header'))).toMatchSnapshot();
  });
  it('should emit open event when show prop is set to true', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
    var onOpen;
    return _regenerator().default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onOpen = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              onOpen: onOpen
            }));
            _context.next = 4;
            return wrapper.setProps({
              visible: true
            });

          case 4:
            expect(onOpen).toHaveBeenCalledTimes(1);

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should emit close event when show prop is set to false', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2() {
    var onClose, onClickCloseIcon;
    return _regenerator().default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onClose = jest.fn();
            onClickCloseIcon = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              onClose: onClose,
              closeable: true,
              onClickCloseIcon: onClickCloseIcon
            }));
            wrapper.setProps({
              visible: true
            });
            wrapper.find('i').simulate('click');
            wrapper.setProps({
              visible: false
            });
            expect(onClose).toHaveBeenCalledTimes(1);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should update width when using width prop', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee3() {
    return _regenerator().default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              visible: true,
              width: 200
            }));
            expect(wrapper.find('.rc-dialog').at(1).getDOMNode().style.width).toEqual('200px');

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('should render footer correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      message: "message",
      footer: /*#__PURE__*/_react().default.createElement(_button.default, null, "Footer")
    }));
    expect(wrapper.find('.rc-dialog').at(1).find('.rc-button__text').text()).toEqual('Footer');
  });
  it('should correctly when showCancelButton prop is true', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      message: "message",
      showCancelButton: true
    }));
    expect(wrapper.find('.rc-dialog').at(1).find('.rc-dialog__cancel').find('.rc-button__text').text()).toEqual('取消');
  });
  it('should correctly when theme prop is round-button', function () {
    wrapper = (0, _enzyme().shallow)( /*#__PURE__*/_react().default.createElement(_.default, {
      visible: true,
      message: "message",
      theme: "round-button",
      showCancelButton: true
    }));
    expect(wrapper.find('.rc-dialog__footer').find('ActionBarButton')).toHaveLength(2);
  });
});