"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _enzymeToJson() {
  var data = _interopRequireDefault(require("enzyme-to-json"));

  _enzymeToJson = function _enzymeToJson() {
    return data;
  };

  return data;
}

var _ = require("..");

var IconFont = _.Icon.createFromIconfontCN('//at.alicdn.com/t/font_2763890_w471tfudy4d.js');

describe('Icon', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
    jest.restoreAllMocks();
  });
  it('should render icon with builtin icon name correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "success"
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should render icon with url name correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "https://img.yzcdn.com/icon.jpg"
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should render default slot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "success"
    }, "Default Slot"));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should change root tag after using tag prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "success",
      tag: "div"
    }, "Default Slot"));
    expect(wrapper.html()).toEqual('<div class="rc-badge__wrapper van-icon van-icon-success">Default Slot</div>');
  });
  it('should render dot correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "success",
      dot: true
    }));
    expect(wrapper.find('.rc-badge').html()).toMatchSnapshot();
  });
  it('should render badge correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "success",
      badge: {
        content: 9
      }
    }));
    expect(wrapper.find('.rc-badge').html()).toMatchSnapshot();
  });
  it('should change icon size when using size prop', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Icon, {
      name: "success",
      size: 20
    }));
    expect(wrapper.getDOMNode().style.fontSize).toEqual('20px');
  });
  it('should render correctly when createFromIconfontCN', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(IconFont, {
      name: "cuIcon-classify",
      color: "#f44336"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
});