"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function React() {
  var data = _interopRequireWildcard(require("react"));

  React = function React() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _react2() {
  var data = require("@testing-library/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

require("@testing-library/jest-dom/extend-expect");

var _ = _interopRequireDefault(require(".."));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var IMAGE_URL = 'https://img.com';
describe('Image', function () {
  afterEach(function () {
    jest.restoreAllMocks();
  });
  it('should emit load event after image loaded', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
    var onLoad, wrapper;
    return _regenerator().default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onLoad = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/React().createElement(_.default, {
              src: IMAGE_URL,
              onLoad: onLoad
            }));
            _context.next = 4;
            return wrapper.find('img').simulate('load');

          case 4:
            expect(onLoad).toHaveBeenCalled();
            expect(wrapper.html()).toMatchSnapshot();

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should watch src and reset', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2() {
    var wrapper;
    return _regenerator().default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/React().createElement(_.default, {
              src: IMAGE_URL
            }));
            _context2.next = 3;
            return wrapper.find('img').simulate('load');

          case 3:
            _context2.next = 5;
            return wrapper.setProps({
              src: ''
            });

          case 5:
            expect(wrapper.html()).toMatchSnapshot();

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should emit error event when load image failed', function () {
    var onError = jest.fn();

    var _render = (0, _react2().render)( /*#__PURE__*/React().createElement(_.default, {
      alt: "errJpg",
      src: IMAGE_URL,
      onError: onError
    })),
        getByAltText = _render.getByAltText;

    _react2().fireEvent.error(getByAltText('errJpg'));

    expect(onError).toHaveBeenCalled();
  });
  it('should not render loading placeholder when show-loading prop is false', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee3() {
    var wrapper;
    return _regenerator().default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/React().createElement(_.default, null));
            expect(wrapper.find('.rc-image__loading').exists()).toBeTruthy();
            _context3.next = 4;
            return wrapper.setProps({
              showLoading: false
            });

          case 4:
            expect(wrapper.find('.rc-image__loading').exists()).toBeFalsy();

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('should not render error placeholder when show-error prop is false', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee4() {
    var _render2, getByAltText, container;

    return _regenerator().default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _render2 = (0, _react2().render)( /*#__PURE__*/React().createElement(_.default, {
              src: IMAGE_URL,
              alt: "test",
              showError: false
            })), getByAltText = _render2.getByAltText, container = _render2.container;

            _react2().fireEvent.error(getByAltText('test'));

            expect(container.querySelector('.rc-image__error')).not.toBeInTheDocument();

          case 3:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
  it('should change loading icon when using loading-icon prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/React().createElement(_.default, {
      loadingIcon: "success"
    }));
    expect(wrapper.find('.van-icon-success').exists()).toBeTruthy();
  });
  it('should render correctly when using width and height prop', function () {
    var _render3 = (0, _react2().render)( /*#__PURE__*/React().createElement(_.default, {
      width: 100,
      height: 100
    })),
        container = _render3.container;

    expect(container.querySelector('.rc-image').getAttribute('style')).toEqual('width: 100px; height: 100px;');
  });
  it('should render correctly when using radius prop', function () {
    var _render4 = (0, _react2().render)( /*#__PURE__*/React().createElement(_.default, {
      width: 100,
      height: 100,
      radius: 10
    })),
        container = _render4.container;

    expect(container.querySelector('.rc-image')).toHaveStyle('border-radius: 10px');
  });
});