"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

var _ = require("..");

describe('Overlay', function () {
  it('should change z-index when using z-index prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Overlay, {
      visible: true,
      zIndex: 99
    }));
    var overlay = wrapper.find('.rc-overlay');
    expect(overlay.getDOMNode().style.zIndex).toEqual('99');
  });
  it('should allow to custom class name with class-name prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Overlay, {
      visible: true,
      className: "foo"
    }));
    var overlay = wrapper.find('.rc-overlay');
    expect(overlay.contains('foo'));
  });
  it('should allow to custom style with custom-style prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Overlay, {
      visible: true,
      customStyle: {
        backgroundColor: 'red'
      }
    }));
    var overlay = wrapper.find('.rc-overlay');
    expect(overlay.getDOMNode().style.backgroundColor).toEqual('red');
  });
  it('should change animation duration when using duration prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Overlay, {
      visible: true,
      duration: 100
    }));
    var overlay = wrapper.find('.rc-overlay');
    expect(overlay.getDOMNode().style.animationDuration).toEqual('100ms');
  });
  it('should render default slot correctly', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Overlay, null, "Custom Default"));
    expect(wrapper).toMatchSnapshot();
  });
});