"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

require("@testing-library/jest-dom/extend-expect");

var _ = _interopRequireDefault(require(".."));

describe('Rate', function () {
  it('should emit change event when rate icon is clicked', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
    var onChange, wrapper, item4;
    return _regenerator().default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onChange = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              onChange: onChange,
              defaultValue: 0
            }));
            item4 = wrapper.find('.rc-rate__item').at(3);
            expect(wrapper.find('i.rc-rate__icon--full').length).toBe(0);
            _context.next = 6;
            return item4.simulate('click');

          case 6:
            expect(onChange).toHaveBeenCalledTimes(1);
            expect(onChange.mock.calls[0][0]).toEqual(4);
            expect(wrapper.find('i.rc-rate__icon--full').length).toBe(4);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it('should not emit change event when rate is not changed', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      onChange: onChange,
      value: 4
    }));
    var item4 = wrapper.find('.rc-rate__item').at(3);
    item4.simulate('click');
    expect(onChange).not.toHaveBeenCalled();
    expect(wrapper.find('i.rc-rate__icon--full').length).toBe(4);
  });
  it('should not emit change or update:modelValue event when rate is disabled', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2() {
    var onChange, wrapper, item4;
    return _regenerator().default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onChange = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              onChange: onChange,
              disabled: true
            }));
            item4 = wrapper.find('.rc-rate__item').at(3);
            item4.simulate('click');
            expect(onChange).not.toHaveBeenCalled();
            expect(wrapper.find('i.rc-rate__icon--full').length).not.toBe(4);

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it('should render gutter when using gutter prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      gutter: 10
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should change icon size when using size prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      size: "2rem"
    }));
    wrapper.find('i.rc-rate__icon').forEach(function (el) {
      expect(el.getDOMNode().style.fontSize).toEqual('2rem');
    });
  });
  it('should get decimal when using allow-half and readonly prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      allowHalf: true,
      readonly: true,
      value: 2.3
    }));
    var halfIcon = wrapper.find('i.rc-rate__icon--half');
    expect(halfIcon.getDOMNode().style.width).toEqual('0.3em');
  });
  it('should render correct count when using string prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
      count: 4
    }));
    var icons = wrapper.find('.rc-rate__item');
    expect(icons).toHaveLength(4);
  });
  it('should emit click event correctly with allowHalf', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee3() {
    var onChange, wrapper;
    return _regenerator().default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onChange = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              allowHalf: true,
              onChange: onChange
            }));
            wrapper.find('.rc-rate__item').at(4).simulate('click', {
              clientX: 92
            });
            expect(onChange).toHaveBeenCalledWith(5);
            wrapper.find('.rc-rate__item').at(0).simulate('click');
            expect(onChange).toHaveBeenCalledWith(0.5);

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  it('touchMove event', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee4() {
    var onChange, wrapper;
    return _regenerator().default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            onChange = jest.fn();
            wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.default, {
              onChange: onChange
            }));
            wrapper.simulate('touchstart', {
              touches: [{
                clientX: 0,
                clientY: 0
              }]
            });
            wrapper.simulate('touchmove', {
              touches: [{
                clientX: 100,
                clientY: 0
              }]
            });
            expect(onChange).toHaveBeenCalled();

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
});