"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

var _ = require("..");

describe('Tag', function () {
  var wrapper;
  afterEach(function () {
    wrapper.unmount();
  });
  it('should emit close event when clicking the close icon', function () {
    var onClose = jest.fn();
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Tag, {
      closeable: true,
      onClose: onClose
    }));
    wrapper.find('.rc-tag__close').at(0).simulate('click');
    expect(onClose).toHaveBeenCalledTimes(1);
  });
  it('should hide tag when the show prop is false', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Tag, {
      visible: false
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
  it('should not trigger click event when clicking the close icon', function () {
    var onClick = jest.fn();
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Tag, {
      closeable: true,
      onClick: onClick
    }));
    wrapper.find('.rc-tag__close').at(0).simulate('click');
    expect(onClick).toHaveBeenCalledTimes(0);
    wrapper.simulate('click');
    expect(onClick).toHaveBeenCalledTimes(1);
  });
  it('should render border-color correctly', function () {
    wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_.Tag, {
      plain: true,
      color: "red",
      textColor: "blue"
    }));
    expect(wrapper.html()).toMatchSnapshot();
  });
});